<template>
  <q-item
      :key="note.title"
      :clickable="!editing"
      :v-ripple="!editing"
      :to="{name: 'Note', params: {path: note.title}}"
  >
    <q-item-section v-if="!editing">
      {{ note.title }}
    </q-item-section>

    <q-item-section v-else>
      <q-input
          borderless
          dense
          v-model="form.title"
          ref="editInput"
       />
    </q-item-section>

    <q-item-section side>
      <div style="display: flex; align-items: center; gap: 4px">
        <q-btn
            @click.prevent="edit"
            :icon="editIcon"
            dense
            flat
            round
        />
        <q-btn
            v-if="!editing"
            @click.prevent="$emit('remove', note.title)"
            icon="delete"
            dense
            flat
            round
        />
      </div>
    </q-item-section>
  </q-item>
</template>


<script lang="ts">
import {defineComponent} from 'vue';
import {Note} from '../wailsjs/go/models'

export default defineComponent({
  emits: ['remove', 'move'],

  props: ['note'],

  data: () => ({
    form: Note.createFrom(),
    editing: false
  }),

  computed: {
    editIcon () {
      return !this.editing
       ? 'edit'
       : this.hasChanges
          ? 'save'
          : 'undo'
    },
    hasChanges () {
      return JSON.stringify(this.form) !== JSON.stringify(this.note)
    }
  },

  watch: {
    note: {
      immediate: true,
      deep: true,
      handler (note) {
        this.form = {...note}
      }
    }
  },

  methods: {
    edit() {
      if (this.editing) {
        this.$emit('move', {from: this.note.title, to: this.form.title});
        this.editing = false;
      } else {
        this.editing = true;
        this.$nextTick(() => {
          (this.$refs.editInput as HTMLInputElement)?.focus()
        });
      }
    }
  }

});
</script>